import { findAllModules } from "./webpack";
;
export const classMap = findAllModules((m) => {
    if (typeof m == "object" && !m.__esModule) {
        const keys = Object.keys(m);
        // special case some libraries
        if (keys.length == 1 && m.version)
            return false;
        // special case localization
        if (keys.length > 1000 && m.AboutSettings)
            return false;
        return keys.length > 0 && keys.every(k => !Object.getOwnPropertyDescriptor(m, k)?.get && typeof m[k] == "string");
    }
    return false;
});
export function findClass(name) {
    return classMap.find(m => m?.[name])?.[name];
}
export function findClassModule(filter) {
    return classMap.find(m => filter(m));
}
export function unminifyClass(minifiedClass) {
    for (let m of classMap) {
        for (let className of Object.keys(m)) {
            if (m[className] == minifiedClass)
                return className;
        }
    }
}
